package com.landray.kmss.sys.attachment.integrate.dianju;

import javax.servlet.ServletException;
import java.sql.SQLException;
import java.math.BigInteger;
import java.sql.ResultSet;
import com.landray.kmss.util.ResourceUtil;
import java.util.List;
import com.landray.kmss.util.FileMimeTypeUtil;
import java.util.Date;
import java.io.InputStream;
import com.landray.kmss.common.model.IBaseModel;
import com.landray.kmss.sys.attachment.model.SysAttMain;
import java.io.ByteArrayInputStream;
import java.io.FileOutputStream;
import java.io.File;
import java.io.IOException;
import com.landray.kmss.util.SpringBeanUtil;
import com.landray.kmss.sys.filestore.service.ISysAttUploadService;
import com.landray.kmss.sys.attachment.service.ISysAttMainCoreInnerService;

public class DianjuFile
{
    private DianjuSmartUpload m_parent;
    private int m_startData;
    private int m_endData;
    private int m_size;
    private String m_fieldname;
    private String m_filename;
    private String m_fileExt;
    private String m_filePathName;
    private String m_contentType;
    private String m_contentDisp;
    private String m_typeMime;
    private String m_subTypeMime;
    private String m_contentString;
    private boolean m_isMissing;
    public static final int SAVEAS_AUTO = 0;
    public static final int SAVEAS_VIRTUAL = 1;
    public static final int SAVEAS_PHYSICAL = 2;
    private ISysAttMainCoreInnerService sysAttMainService;
    private ISysAttUploadService sysAttUploadService;
    
    protected ISysAttMainCoreInnerService getServiceImp() {
        if (this.sysAttMainService == null) {
            this.sysAttMainService = (ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService");
        }
        return this.sysAttMainService;
    }
    
    protected ISysAttUploadService getSysAttUploadService() {
        if (this.sysAttUploadService == null) {
            this.sysAttUploadService = (ISysAttUploadService)SpringBeanUtil.getBean("sysAttUploadService");
        }
        return this.sysAttUploadService;
    }
    
    DianjuFile() {
        this.m_startData = 0;
        this.m_endData = 0;
        this.m_size = 0;
        this.m_fieldname = new String();
        this.m_filename = new String();
        this.m_fileExt = new String();
        this.m_filePathName = new String();
        this.m_contentType = new String();
        this.m_contentDisp = new String();
        this.m_typeMime = new String();
        this.m_subTypeMime = new String();
        this.m_contentString = new String();
        this.m_isMissing = true;
        this.sysAttMainService = null;
        this.sysAttUploadService = null;
    }
    
    public void saveAs(final String s) throws IOException, DianjuSmartUploadException {
        this.saveAs(s, 0);
    }
    
    public void saveAs(final String s, final int i) throws IOException, DianjuSmartUploadException {
        new String();
        final String s2 = this.m_parent.getPhysicalPath(s, i);
        if (s2 == null) {
            throw new IllegalArgumentException("There is no specified destination file (1140).");
        }
        try {
            final File file = new File(s2);
            final FileOutputStream fileoutputstream = new FileOutputStream(file);
            fileoutputstream.write(this.m_parent.m_binArray, this.m_startData, this.m_size);
            fileoutputstream.close();
        }
        catch (final IOException ex) {
            throw new DianjuSmartUploadException("File can't be saved (1120).");
        }
    }
    
    public void saveToAttmain(final DianjuSaveRequestVO dianjuSaveRequestVO) throws IOException, DianjuSmartUploadException {
        if ("attachment".equals(dianjuSaveRequestVO.getType())) {
            this.saveSysAttMain(dianjuSaveRequestVO);
        }
        else {
            this.saveAttMaint(dianjuSaveRequestVO);
        }
    }
    
    public void saveSysAttMain(final DianjuSaveRequestVO dianjuSaveRequestVO) throws IOException, DianjuSmartUploadException {
        new String();
        final String attMainId = dianjuSaveRequestVO.getAttMainId();
        InputStream in = null;
        try {
            in = new ByteArrayInputStream(this.m_parent.m_binArray, this.m_startData, this.m_size);
            final SysAttMain sysAttMain = (SysAttMain)this.getServiceImp().findByPrimaryKey(attMainId);
            sysAttMain.setInputStream(in);
            this.getServiceImp().update((IBaseModel)sysAttMain);
        }
        catch (final Exception ex) {
            throw new DianjuSmartUploadException("File can't be saved (1121).");
        }
        finally {
            if (in != null) {
                in.close();
            }
        }
        if (in != null) {
            in.close();
        }
    }
    
    public void saveAttMaint(final DianjuSaveRequestVO dianjuSaveRequestVO) throws IOException, DianjuSmartUploadException {
        new String();
        final String modelId = dianjuSaveRequestVO.getModelId();
        final String modelName = dianjuSaveRequestVO.getModelName();
        final String fileName = dianjuSaveRequestVO.getFileName();
        InputStream in = null;
        try {
            in = new ByteArrayInputStream(this.m_parent.m_binArray, this.m_startData, this.m_size);
            final List<SysAttMain> attMainList = this.getServiceImp().findByModelKey(modelName, modelId, "dianjuSign");
            if (attMainList != null && attMainList.size() > 0) {
                final SysAttMain attMain = attMainList.get(0);
                final String attMainfileName = attMain.getFdFileName();
                final String extendName = DianjuUtil.getFileSuffix(attMainfileName);
                if (".ofd".equals(extendName) || ".pdf".equals(extendName)) {
                    attMain.setInputStream(in);
                    this.getServiceImp().update((IBaseModel)attMain);
                    return;
                }
            }
            String saveFileName = String.valueOf(DianjuUtil.getFileName(fileName)) + ".ofd";
            final String fileNameSuffix = DianjuUtil.getFileSuffix(fileName);
            if (".pdf".equals(fileNameSuffix)) {
                saveFileName = String.valueOf(DianjuUtil.getFileName(fileName)) + ".pdf";
            }
            final SysAttMain sysAttMain = new SysAttMain();
            sysAttMain.setDocCreateTime(new Date());
            sysAttMain.setFdFileName(saveFileName);
            sysAttMain.setFdSize(Double.valueOf((double)this.m_parent.m_binArray.length));
            sysAttMain.setDocCreateTime(new Date());
            final String contentType = FileMimeTypeUtil.getContentType(saveFileName);
            sysAttMain.setFdContentType(contentType);
            sysAttMain.setInputStream(in);
            sysAttMain.setFdKey("dianjuSign");
            sysAttMain.setFdModelId(modelId);
            sysAttMain.setFdModelName(modelName);
            sysAttMain.setFdAttType("byte");
            this.getServiceImp().add((IBaseModel)sysAttMain);
        }
        catch (final Exception ex) {
            throw new DianjuSmartUploadException("File can't be saved (1121).");
        }
        finally {
            if (in != null) {
                in.close();
            }
        }
        if (in != null) {
            in.close();
        }
    }
    
    public String getSystemUrl() {
        String basePath = ResourceUtil.getKmssConfigString("kmss.resource.path");
        if (basePath.endsWith("/")) {
            basePath = basePath.substring(0, basePath.lastIndexOf("/"));
        }
        return basePath;
    }
    
    public byte[] getBytes() throws Exception {
        final byte[] src = this.m_parent.m_binArray;
        final byte[] bts = new byte[this.m_size];
        for (int i = 0; i < this.m_size; ++i) {
            bts[i] = src[this.m_startData + i];
        }
        return bts;
    }
    
    public void fileToField(final ResultSet resultset, final String s) throws ServletException, IOException, DianjuSmartUploadException, SQLException {
        long l = 0L;
        final int i = 65536;
        int k = this.m_startData;
        if (resultset == null) {
            throw new IllegalArgumentException("The RecordSet cannot be null (1145).");
        }
        if (s == null) {
            throw new IllegalArgumentException("The columnName cannot be null (1150).");
        }
        if (s.length() == 0) {
            throw new IllegalArgumentException("The columnName cannot be empty (1155).");
        }
        l = BigInteger.valueOf(this.m_size).divide(BigInteger.valueOf(i)).longValue();
        final int j = BigInteger.valueOf(this.m_size).mod(BigInteger.valueOf(i)).intValue();
        try {
            for (int i2 = 1; i2 < l; ++i2) {
                resultset.updateBinaryStream(s, new ByteArrayInputStream(this.m_parent.m_binArray, k, i), i);
                k = ((k != 0) ? k : 1);
                k = i2 * i + this.m_startData;
            }
            if (j > 0) {
                resultset.updateBinaryStream(s, new ByteArrayInputStream(this.m_parent.m_binArray, k, j), j);
            }
        }
        catch (final SQLException ex) {
            final byte[] abyte0 = new byte[this.m_size];
            System.arraycopy(this.m_parent.m_binArray, this.m_startData, abyte0, 0, this.m_size);
            resultset.updateBytes(s, abyte0);
        }
        catch (final Exception ex2) {
            throw new DianjuSmartUploadException("Unable to save file in the DataBase (1130).");
        }
    }
    
    public boolean isMissing() {
        return this.m_isMissing;
    }
    
    public String getFieldName() {
        return this.m_fieldname;
    }
    
    public String getFileName() {
        return this.m_filename;
    }
    
    public String getFilePathName() {
        return this.m_filePathName;
    }
    
    public String getFileExt() {
        return this.m_fileExt;
    }
    
    public String getContentType() {
        return this.m_contentType;
    }
    
    public String getContentDisp() {
        return this.m_contentDisp;
    }
    
    public String getContentString() {
        final String s = new String(this.m_parent.m_binArray, this.m_startData, this.m_size);
        return s;
    }
    
    public String getTypeMIME() throws IOException {
        return this.m_typeMime;
    }
    
    public String getSubTypeMIME() {
        return this.m_subTypeMime;
    }
    
    public int getSize() {
        return this.m_size;
    }
    
    protected int getStartData() {
        return this.m_startData;
    }
    
    protected int getEndData() {
        return this.m_endData;
    }
    
    protected void setParent(final DianjuSmartUpload smartupload) {
        this.m_parent = smartupload;
    }
    
    protected void setStartData(final int i) {
        this.m_startData = i;
    }
    
    protected void setEndData(final int i) {
        this.m_endData = i;
    }
    
    protected void setSize(final int i) {
        this.m_size = i;
    }
    
    protected void setIsMissing(final boolean flag) {
        this.m_isMissing = flag;
    }
    
    protected void setFieldName(final String s) {
        this.m_fieldname = s;
    }
    
    protected void setFileName(final String s) {
        this.m_filename = s;
    }
    
    protected void setFilePathName(final String s) {
        this.m_filePathName = s;
    }
    
    protected void setFileExt(final String s) {
        this.m_fileExt = s;
    }
    
    protected void setContentType(final String s) {
        this.m_contentType = s;
    }
    
    protected void setContentDisp(final String s) {
        this.m_contentDisp = s;
    }
    
    protected void setTypeMIME(final String s) {
        this.m_typeMime = s;
    }
    
    protected void setSubTypeMIME(final String s) {
        this.m_subTypeMime = s;
    }
    
    public byte getBinaryData(final int i) {
        if (this.m_startData + i > this.m_endData) {
            throw new ArrayIndexOutOfBoundsException("Index Out of range (1115).");
        }
        return (byte)((this.m_startData + i <= this.m_endData) ? this.m_parent.m_binArray[this.m_startData + i] : 0);
    }
}
